=== debian/changelog ===
ros-galactic-nao-lola (0.0.5-1focal) focal; urgency=high

  * Split off galactic and humble branches
  * Fix status test to use int rather than float
  * Contributors: Kenji Brameld

 -- ijnek <kenjibrameld@gmail.com>  Wed, 20 Jul 2022 15:00:00 -0000

ros-galactic-nao-lola (0.0.4-1focal) focal; urgency=high

  * fix cpplint warning
  * add changes to ci to test all distros
  * Contributors: Kenji Brameld, ijnek

 -- ijnek <kenjibrameld@gmail.com>  Thu, 03 Feb 2022 15:00:00 -0000

ros-galactic-nao-lola (0.0.3-1focal) focal; urgency=high

  * add ament_cmake_gtest and boost dependency in package.xml and CMakeLists.txt
  * Contributors: Kenji Brameld

 -- ijnek <kenjibrameld@gmail.com>  Wed, 28 Jul 2021 15:00:00 -0000

ros-galactic-nao-lola (0.0.2-1focal) focal; urgency=high

  * specify license and update package description
  * Contributors: Kenji Brameld

 -- ijnek <kenjibrameld@gmail.com>  Mon, 19 Jul 2021 15:00:00 -0000

ros-galactic-nao-lola (0.0.1-1focal) focal; urgency=high

  * Initial impelementation
  * Contributors: Kenji Brameld

 -- ijnek <kenjibrameld@gmail.com>  Fri, 16 Jul 2021 15:00:00 -0000
